function [classifier,hits,Cx] = gentleTemporalBoost(x, y, Nrounds, TemExt, plotstyle)

%
% features x
% class: y = [-1,1]
%
%
% Implementation of gentleTemporalBoost:
%  Pedro & Plinio, 2006

% By default there is no visualization
if nargin < 5; plotstyle = []; end

[Nfeatures, Nsamples] = size(x); % Nsamples = Number of thresholds that we will consider
Fx = zeros(1, Nsamples);
w  = ones(1, Nsamples);
Tmax=0;
for m = 1:Nrounds
    disp(sprintf('Round %d', m))
    % Weak regression stump: It is defined by four parameters (a,b,k,th)
    %     f_m = a * (x_k > th) + b
    [k, th, a , b, Te ,error] = selectBestTemporalStump(x, y, w,TemExt);
    % update parameters classifier
    classifier(m).featureNdx = k;
    classifier(m).th = th;
    classifier(m).a  = a;
    classifier(m).b  = b;
    classifier(m).T = Te;
    classifier(m).err = error;
    % Updating and computing classifier output on training samples
    for i = Te:Nsamples
        PHI(i) = length( find( x(k,i-Te+1:i) > th ) )/Te;
        CHI(i) = length( find( x(k,i-Te+1:i) <= th ) )/Te;
    end
    fm  = 1 * (a * PHI + b * CHI); % evaluate weak classifier
    if Tmax<Te
        Tmax=Te;
    end
    Fx = Fx + fm; % update strong classifier
    Cx=sign(Fx);
    hits(m) = length(find(Cx([Tmax:end]).*y([Tmax:end])>0))/length(Cx([Tmax:end]));

    % Reweight training samples
    w = w .* exp(-y.*fm);

    % Plot results on a 2D space
    if size(plotstyle,1)>0;
        plotw(x(1,:), x(2,:), w, y, plotstyle);
        pause;
    end
end

%TEMPORAL CONSISTENCY (DON'T WORK DIRECTLY, a AND b MUST BE OPTIMIZED AGAIN....)
%     Tmaximum=TemExt*Nsamples;
%     fm_=fm;
%     fm_(end:end+Tmaximum)=0;
%     for i=0:Tmaximum
%         fmCons(i+1,:) = circshift(fm_,[1 -i]);
%     end
%     fm=sum(fmCons(:,[1:end-Tmaximum]),1)/Tmaximum;
%%%%%%%%%%%%%%%%%% MUST BE PLACED CORRECTLY!!!!
