function [featureNdx, th, a , b, T, error] = selectBestTemporalStump(x, z, w,TempExt);

% [th, a , b] = fitRegressionStump(x, z, w);
% h(x_(i)) = 1/T * sum_(t=0)^(T-1) (a * (x_(i-t)>th) + b * (x_(i-t)<=th) );
%
% where (a,b,th) are so that it minimizes the weighted error:
% error = sum(w * (z - sum_(t=0)^(T-1) (a*(x_(i-t)>th) + b * (x_(i-t)<=th) ) ) ^2 ) / sum(w)

% Pedro & Plinio, 2006


[Nfeatures, Nsamples] = size(x); % Nsamples = Number of thresholds that we will consider
w = w/sum(w); % just in case...

th = zeros(1,Nfeatures);
a = zeros(1,Nfeatures);
b = zeros(1,Nfeatures);
error = zeros(1,Nfeatures);
T = zeros(1,Nfeatures);
for i = 1:Nfeatures
    [th(i), a(i) , b(i), T(i), error(i)] = fitTemporalStump(x(i,:), z, w, TempExt);
end
[error, featureNdx] = min(error);
T=T(featureNdx);
th = th(featureNdx);
a = a(featureNdx);
b = b(featureNdx);
